/*
 * @file  io_board.h
 * @brief HSBRX65_IO_BOARDhCowb_
 *
 * {\tgEFA̒쌠͍쐬ł()kldqL̂ƂA
 * ()kldq́Aȉ (1)-(3) ̏𖞂ꍇɌA
 * {\tgEFAi{\tgEFAς̂܂ށBȉj
 * gpEEρEĔzziȉApƌĂԁj邱Ƃ𖳏ŋB
 *
 * (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́AL̒
 *	   \A̗pÂ܂܂̌`Ń\[XR[hɊ܂܂
 *	   邱ƁB
 * (2) {\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ֎~
 *	   ƂBGȂǂ֏ЉE^̏ꍇ()kldqɘA肢܂B
 * (3) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹Q
 *	   A()kldq͈؂̐ӔC𕉂Ȃ̂ƂB
 *
 * Copyright (C) Hokuto denshi Co,Ltd. 2024
 */

#ifndef IO_BOARD_H__
#define IO_BOARD_H__

/*----------------------------------------------------------------------
    萔`
----------------------------------------------------------------------*/
//߂l
#define RET_SUCCESS					(0)		//
#define RET_ERROR					(-1)	//G[

//LE
#define ENABLE						(1)
#define DISABLE						(0)

//CMT3ŏe@\
#define IOBOARD_ADC					(0)
#define IOBOARD_LED7SEG				(1)
#define IOBOARD_MATRIXSW			(2)

#define IOBOARD_CMT3_FUNCTION_NUM	(3)		//CMT3"ADC", "7ZOLED", "}gbNXXCb`"3ނ̋@\

//ADC̈ړ
#define IOBOARD_ADC_AVERAGE_NUM		(16)	//16f[^̈ړς

//7ZOLED
#define IOBOARD_LED7SEG_COM			(4)		//COMM4{
#define IOBOARD_LED7SEG_COM1		(0)
#define IOBOARD_LED7SEG_COM2		(1)
#define IOBOARD_LED7SEG_COM3		(2)
#define IOBOARD_LED7SEG_COM4		(3)

//}gbNXXCb`
#define IOBOARD_MATRIXSW_NUM		(16)
#define IOBOARD_SW11				(0)
#define IOBOARD_SW12				(1)
#define IOBOARD_SW13				(2)
#define IOBOARD_SW14				(3)
#define IOBOARD_SW15				(4)
#define IOBOARD_SW16				(5)
#define IOBOARD_SW17				(6)
#define IOBOARD_SW18				(7)
#define IOBOARD_SW19				(8)
#define IOBOARD_SW20				(9)
#define IOBOARD_SW21				(10)
#define IOBOARD_SW22				(11)
#define IOBOARD_SW23				(12)
#define IOBOARD_SW24				(13)
#define IOBOARD_SW25				(14)
#define IOBOARD_SW26				(15)

#define PCLKB						(60)	//PCLKB=60MHz

/*----------------------------------------------------------------------
	O[oϐ
----------------------------------------------------------------------*/
extern volatile int g_function_use[IOBOARD_CMT3_FUNCTION_NUM];
extern volatile int g_adc_flag;
extern volatile unsigned short g_adc_result;
extern volatile unsigned char g_led7seg_data[IOBOARD_LED7SEG_COM];
extern volatile unsigned char g_matrixsw[IOBOARD_MATRIXSW_NUM];
extern volatile unsigned short g_tpu2_tgra;
extern volatile unsigned short g_tpu2_tgrb;

/*----------------------------------------------------------------------
	֐vg^Cv錾
----------------------------------------------------------------------*/
extern int push_sw_init(void);
extern unsigned char push_sw_read(void);
extern int intr_push_sw_init(int timing);
extern int intr_push_sw_start(void);
extern int intr_push_sw_stop(void);
extern int led_init(void);
extern int led_set(unsigned char led);
extern int buzzer_freq_set(unsigned short freq);
extern int buzzer_on(void);
extern int buzzer_off(void);
extern int led8_cycle_set(unsigned short cycle);
extern int led8_duty_set(float duty);
extern int led8_on(void);
extern int led8_off(void);
extern int stepping_motor_init(void);
extern int stepping_motor_stop(void);
extern int stepping_motor_step_move(int direction);
extern int stepping_motor_drive(unsigned char pattern);
extern int adc_start(void);
extern int adc_stop(void);
extern unsigned short adc_val(void);
extern int led7seg_init(void);
extern int led7seg_start(void);
extern int led7seg_stop(void);
extern int led7seg_segument_data_set(unsigned char column, unsigned char seg, unsigned char seg_on_off);
extern int led7seg_disp_hex(unsigned short data);
extern int led7seg_disp_num(short data, unsigned char dp);
extern int matrixsw_init(void);
extern int matrixsw_start(void);
extern int matrixsw_stop(void);
extern int matrixsw_read(unsigned char key);

#endif